<template>
  <a-form v-if="vdata.currentConfig" ref="formRef" :model="vdata.currentConfig" layout="vertical" :rules="vdata.formRules">
    <a-divider orientation="left">
      <a-tag color="#FF4B33">飞鹅云打印参数配置</a-tag>
    </a-divider>
    <a-row justify="space-between" type="flex">
      <a-col :span="11">
        <a-form-item label="飞鹅云后台帐号名USER" name="user">
          <a-input v-model:value.trim="vdata.currentConfig.user" placeholder="请输入" />
        </a-form-item>
      </a-col>
      <a-col :span="11">
        <a-form-item label="飞鹅云后台帐号UKEY" name="ukey">
          <a-input v-model:value.trim="vdata.currentConfig.ukey" :placeholder="vdata.configDataDesen.ukey || '请输入'" />
        </a-form-item>
      </a-col>
    </a-row>
  </a-form>
</template>

<script lang="ts" setup>
import {reactive, ref, defineExpose} from 'vue'
 
  // 当前的form
  const formRef = ref()

  const  vdata = reactive({
    // 配置对象
    currentConfig: {} as any,
    configDataDesen: {
      ukey: ''
    },
    // 表单规则
    formRules: {
      user: [{ required: true, message: '请输入飞鹅云后台帐号名USER', trigger: 'blur' }],
      ukey: [{ required: false, trigger: 'blur' }, {
        validator: (rule, value) => {
          if (!vdata.configDataDesen.ukey && !value) {
            return Promise.reject('请输入飞鹅云后台帐号UKEY')
          }
          return Promise.resolve()
        }
      }]
    }
  })

  // 对外提供的页面的渲染函数 （ ifDefineArray = 接口的配置定义项数组，  currentConfig = 当前配置项 ）
function pageRender(currentConfig: any){
  // 赋值
  if (currentConfig) {
    vdata.currentConfig = currentConfig
  }

  vdata.configDataDesen.ukey = vdata.currentConfig.ukey
  vdata.currentConfig.ukey = ''

  // 重置form验证
  if (formRef.value !== undefined && formRef.value !== null) {
    formRef.value.resetFields()
  }
}

// 对外提供的获取配置参数函数 （返回JSON类型）
function getConfigParams(){
  return formRef.value.validate().then( () => {

    // 处理加密数据字段
    Object.keys(vdata.configDataDesen).forEach(key => {
      // 加密数据 && 空串
      if (!vdata.currentConfig[key]) {
        delete vdata.currentConfig[key]
      }
    })
    return vdata.currentConfig
  })
}

defineExpose({ getConfigParams, pageRender })

</script>
